
:- module(rewrite,[ rewrite/2 ],[ ]).

%% :- use_module(engine(arithmetic),[ is/2 ]).
%% :- use_module(engine(term_basic),[ arg/3, functor/3 ]).
%% :- use_module(engine(term_typing),[ atomic/1 ]).
:- use_module(formula).

:- use_module(native_props,[mshare/1]).

rewrite(Atom,Atom) :-
	atomic(Atom), !.
rewrite(Old,New) :-
	functor(Old,F,N),
	functor(Mid,F,N),
	rewrite_args(N,Old,Mid),
/* NOT WORKING:
	( equal(Mid,Next),    % should be ->, but is compiler smart enough?
	  rewrite(Next,New)    % to generate cut for ->?
	; New=Mid
	),!.
*/
	'rewrite/2/2/$disj/1'(New,Mid), !.

'rewrite/2/2/$disj/1'(New,Mid) :-
        equal(Mid,Next),
        rewrite(Next,New).
'rewrite/2/2/$disj/1'(New,Mid) :-
        New=Mid.

rewrite_args(0,_,_) :- !.
rewrite_args(N,Old,Mid) :-
	arg(N,Old,OldArg),
	arg(N,Mid,MidArg),
	rewrite(OldArg,MidArg),
	N1 is N-1,
	rewrite_args(N1,Old,Mid).

